﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Windows.Chart;

namespace xamChart_piechartbinding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        PieChartSampleData m_collection = new PieChartSampleData();

        public MainWindow()
        {
            InitializeComponent();
        }

        private void btnBindData(object sender, RoutedEventArgs e)
        {
            // Show the data chart.
            xamChart1.Visibility = System.Windows.Visibility.Visible;

            Series pieSeries = new Series();
            pieSeries.Label = "Pie Chart Series";
            pieSeries.ChartType = ChartType.Pie;
            pieSeries.DataPoints.Add(new DataPoint() { Label = "Test1", Value = 1, });
            pieSeries.DataPoints.Add(new DataPoint() { Label = "Test2", Value = 2, });
            pieSeries.DataPoints.Add(new DataPoint() { Label = "Test3", Value = 3, });
            pieSeries.DataPoints.Add(new DataPoint() { Label = "Test4", Value = 4, });
            pieSeries.DataPoints.Add(new DataPoint() { Label = "Test5", Value = 5, });
            pieSeries.DataPoints.Add(new DataPoint() { Label = "Test6", Value = 6, });
            xamChart1.Series.Add(pieSeries);
        }
    }

    public class DataItem : INotifyPropertyChanged
    {
        string _category;
        string _label;
        double _value;

        #region Properties
        public string Category
        {
            get
            {
                return _category;
            }
            set
            {
                _category = value;
                OnPropertyChanged("Category");
            }
        }
        public string Label
        {
            get
            {
                return _label;
            }
            set
            {
                _label = value;
                OnPropertyChanged("Label");
            }
        }
        public double Value
        {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
                OnPropertyChanged("Value");
            }
        }
        #endregion

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }

    public class PieChartSampleData : ObservableCollection<DataItem>
    {
        public PieChartSampleData()
        {
            Add(new DataItem { Category = "Cat-A", Label = "Item 1", Value = 5 });
            Add(new DataItem { Category = "Cat-B", Label = "Item 2", Value = 6 });
            Add(new DataItem { Category = "Cat-C", Label = "Item 3", Value = 3 });
            Add(new DataItem { Category = "Cat-D", Label = "Item 4", Value = 7 });
            Add(new DataItem { Category = "Cat-E", Label = "Item 5", Value = 5 });
            Add(new DataItem { Category = "Cat-F", Label = "Item 6", Value = 2 });
            Add(new DataItem { Category = "Cat-G", Label = "Item 7", Value = 1 });
        }
    }
}
